import { computed as m, onMounted as ot, ref as b, watch as lt, createElementBlock as y, openBlock as c, unref as v, normalizeStyle as F, normalizeClass as He, createBlock as H, createCommentVNode as x, createElementVNode as Y, createVNode as de, createSlots as at, withCtx as $, renderSlot as k, normalizeProps as D, guardReactiveProps as B, Fragment as U, renderList as V, toDisplayString as W, createTextVNode as nt, nextTick as st } from "vue";
import { u as rt, o as ut, e as it, c as ve, t as ct, p as L, a as dt, b as vt, v as _, d as ft, f as j, X as ht, G as Ye, J as pt, i as fe, q as gt, r as mt, x as yt } from "./index-Co5UfCMK.js";
import { _ as bt } from "./Title-tlFeM12I.js";
import { u as kt, U as Ct } from "./usePrinter-D_wgo-7k.js";
import { D as wt } from "./DataTable-CX-Ynkp4.js";
import $t from "./vue-ui-accordion-CfB_jW1X.js";
import _t from "./vue-ui-skeleton-BSlYUHZA.js";
import { u as De } from "./useNestedProp-C22WP03t.js";
import { _ as Tt } from "./PackageVersion-CkUbRQrt.js";
import { _ as xt } from "./PenAndPaper-Br3OdauM.js";
import { u as Nt } from "./useUserOptionState-BIvW1Kz7.js";
import { u as Ot } from "./useChartAccessibility-BWojgys7.js";
import { _ as St } from "./Tooltip-BCtHh3BT.js";
import { L as Ft } from "./Legend-BTvPguV6.js";
import { _ as Lt } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const Pt = ["id"], It = {
  key: 1,
  ref: "noTitle",
  class: "vue-data-ui-no-title-space",
  style: "height:36px; width: 100%;background:transparent"
}, Et = {
  key: 2,
  style: "width:100%;background:transparent;padding-bottom:24px"
}, zt = ["xmlns", "viewBox"], At = ["width", "height"], Mt = ["id"], Ht = ["stop-color"], Yt = ["stop-color"], Dt = ["d", "fill", "stroke", "stroke-width"], Bt = ["x", "y", "height", "width", "fill", "stroke", "stroke-width", "onMouseenter"], Gt = ["x", "y", "font-size", "fill"], Rt = ["x", "y", "font-size", "fill"], Ut = {
  key: 4,
  class: "vue-data-ui-watermark"
}, Vt = ["onClick"], Wt = {
  key: 6,
  ref: "source",
  dir: "auto"
}, jt = ["innerHTML"], Xt = {
  __name: "vue-ui-flow",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Array,
      default() {
        return [];
      }
    }
  },
  setup(Be, { expose: Ge }) {
    const { vue_ui_flow: Re } = rt(), T = Be, te = m(() => !!T.dataset && T.dataset.length);
    ot(() => {
      he();
    });
    function he() {
      ut(T.dataset) && it({
        componentName: "VueUiFlow",
        type: "dataset"
      });
    }
    const oe = b(ve()), le = b(null), pe = b(0), ge = b(0), ae = b(!1), ne = b(""), Ue = b(null), E = b(!1);
    function Ve(t) {
      E.value = t, pe.value += 1;
    }
    const e = m({
      get: () => ke(),
      set: (t) => t
    }), { userOptionsVisible: se, setUserOptionsVisibility: me, keepUserOptionState: ye } = Nt({ config: e.value }), { svgRef: be } = Ot({
      config: e.value.style.chart.title
    });
    function ke() {
      const t = De({
        userConfig: T.config,
        defaultConfig: Re
      });
      let l = t;
      return t.theme ? l = {
        ...De({
          userConfig: dt.vue_ui_flow[t.theme] || T.config,
          defaultConfig: t
        }),
        customPalette: ct[t.theme] || L
      } : l = t, l.nodeCategories = T.config.nodeCategories || {}, l.nodeCategoryColors = T.config.nodeCategoryColors || {}, l;
    }
    lt(
      () => T.config,
      (t) => {
        e.value = ke(), se.value = !e.value.userOptions.showOnChartHover, he(), ge.value += 1, N.value.showTable = e.value.table.show;
      },
      { deep: !0 }
    );
    const { isPrinting: Ce, isImaging: we, generatePdf: $e, generateImage: _e } = kt({
      elementId: `flow_${oe.value}`,
      fileName: e.value.style.chart.title.text || "vue-ui-flow",
      options: e.value.userOptions.print
    }), We = m(() => e.value.userOptions.show && !e.value.style.chart.title.text), X = m(() => vt(e.value.customPalette)), Te = m(() => e.value.style.chart.nodes.gap), z = m(() => e.value.style.chart.nodes.width), N = b({
      showTable: e.value.table.show,
      showTooltip: e.value.style.chart.tooltip.show
    }), xe = m(() => e.value.style.chart.links.width), q = m(() => !T.dataset || !T.dataset.length ? [] : T.dataset.map((t, l) => [
      t[0],
      t[1],
      _(t[2]),
      t[3] ? ft(t[3]) : X.value[l] || X.value[l % X.value.length] || L[l] || L[l % d.length]
    ])), Ne = m(() => {
      const t = {};
      function l(a) {
        t[a] || (t[a] = { inflow: 0, outflow: 0 });
      }
      q.value.forEach(([a, s, p]) => {
        l(a), l(s), t[a].outflow += p, t[s].inflow += p;
      });
      let o = 0;
      for (const a in t) {
        const s = Math.max(t[a].inflow, t[a].outflow);
        o = Math.max(o, s);
      }
      return o;
    });
    function je(t) {
      return t / Ne.value * 100 + e.value.style.chart.nodes.minHeight;
    }
    function Xe(t) {
      const l = e.value.style.chart.nodes.minHeight;
      return (t - l) / 100 * Ne.value;
    }
    function qe(t) {
      const l = {}, o = {};
      function a(n, u) {
        l[n] || (l[n] = {
          height: 0,
          level: null,
          inflow: 0,
          outflow: 0,
          uid: ve()
        }), l[n].level === null && (l[n].level = u), o[u] || (o[u] = []), o[u].includes(n) || o[u].push(n);
      }
      t.forEach(([n, u, i]) => {
        var r;
        const f = ((r = l[n]) == null ? void 0 : r.level) ?? 0, g = f + 1;
        a(n, f), a(u, g), l[n].children || (l[n].children = []), l[n].children.push({ target: u, value: i }), l[n].outflow += i, l[u].inflow += i;
      });
      const s = new Set(t.map(([n]) => n)), p = new Set(t.map(([, n]) => n)), M = Array.from(s).filter((n) => !p.has(n)), Q = {};
      M.forEach((n, u) => {
        Q[n] = X.value[u] || L[u % L.length];
      });
      const R = {};
      t.forEach(([n, u, i, f]) => {
        f && (R[n] = f, R[u] = f);
      }), Object.keys(l).forEach((n, u) => {
        var g, r;
        const i = (g = e.value.nodeCategories) == null ? void 0 : g[n], f = i ? (r = e.value.nodeCategoryColors) == null ? void 0 : r[i] : null;
        l[n].color = R[n] || // 1) explicit
        f || // 2) category
        (M.includes(n) ? Q[n] : null) || // 3) root
        L[u % L.length];
      });
      for (const n in l)
        l[n].height = je(
          Math.max(l[n].inflow, l[n].outflow)
        ), l[n].name = n;
      const O = {};
      for (const n in o) {
        let u = 0;
        o[n].forEach((i, f) => {
          const g = l[i];
          O[i] = {
            x: parseInt(n, 10) * xe.value + e.value.style.chart.padding.left,
            y: u,
            absoluteY: u,
            height: g.height,
            i: f,
            color: g.color,
            value: Xe(g.height)
          }, u += g.height + Te.value;
        });
      }
      const I = [];
      for (const n of Object.keys(l)) {
        let u = O[n].absoluteY + e.value.style.chart.padding.top;
        const i = l[n], f = O[n];
        i.children && i.children.forEach(({ target: g, value: r }) => {
          const h = O[g], S = l[g], ee = _(u), Ae = _(
            u + r / i.outflow * f.height
          ), ce = _(
            h.y + e.value.style.chart.padding.top
          ), Me = _(
            ce + r / S.inflow * h.height
          );
          I.push({
            id: ve(),
            source: n,
            target: g,
            path: `M ${_(f.x + z.value)} ${ee} L ${_(f.x + z.value)} ${Ae} L ${_(h.x)} ${Me} L ${_(h.x)} ${ce} Z`,
            value: r,
            sourceColor: i.color,
            targetColor: S.color
          }), u += Ae - ee, O[g].y += Me - ce;
        });
      }
      return { nodeCoordinates: O, links: I };
    }
    const C = m(() => {
      const t = qe(T.dataset);
      return {
        nodes: Object.keys(t.nodeCoordinates).map((l, o) => ({
          ...t.nodeCoordinates[l],
          name: l
        })),
        links: t.links
      };
    }), Je = m(() => Ze(C.value.nodes));
    function Ze(t) {
      const l = {};
      for (const a in t) {
        const { x: s, height: p } = t[a];
        l[s] || (l[s] = 0), l[s] += p + Te.value;
      }
      return Math.max(...Object.values(l));
    }
    const G = m(() => {
      const {
        top: t,
        right: l,
        left: o,
        bottom: a
      } = e.value.style.chart.padding, s = q.value.length * xe.value;
      return {
        height: Je.value + t + a,
        width: l + Math.max(...C.value.nodes.map((p) => p.x)) + z.value,
        left: o,
        top: t,
        right: s - l,
        p_top: t,
        p_bottom: a
      };
    });
    function Ke(t) {
      const l = {}, o = {}, a = /* @__PURE__ */ new Set();
      return q.value.forEach(([s, p, M]) => {
        l[s] || (l[s] = []), o[p] || (o[p] = []), l[s].push(p), o[p].push(s);
      }), l[t] && l[t].forEach((s) => a.add(s)), o[t] && o[t].forEach((s) => a.add(s)), Array.from(a).concat(t);
    }
    const w = b(null), A = b(null), re = b(null), J = b(!1);
    function Qe(t) {
      P.value = [], w.value = Ke(t.name), A.value = t.name;
      const l = t.name, o = q.value;
      let a = 0, s = 0, p = [], M = [];
      const Q = new Set(o.map(([r]) => r)), R = new Set(o.map(([, r]) => r)), ze = Array.from(Q).filter((r) => !R.has(r)), O = o.filter(([r]) => ze.includes(r)).reduce((r, [h, S, ee]) => r + ee, 0), I = {};
      C.value.nodes.forEach((r) => {
        I[r.name] = r.color;
      }), o.forEach(([r, h, S]) => {
        h === l && (a += S, p.push({ source: r, value: S, color: I[r] })), r === l && (s += S, M.push({ target: h, value: S, color: I[h] }));
      });
      const n = Math.max(a, s), u = O > 0 ? n / O * 100 : 0, i = {
        name: l,
        inflow: a,
        outflow: s,
        from: p,
        to: M,
        percentOfTotal: u,
        color: I[l] || "#000000"
      };
      re.value = { datapoint: i }, ae.value = !0;
      let f = "";
      const g = e.value.style.chart.tooltip.customFormat;
      if (J.value = !1, yt(g))
        try {
          const r = g({
            datapoint: i,
            series: C.value,
            config: e.value
          });
          typeof r == "string" && (ne.value = r, J.value = !0);
        } catch {
          console.warn("Custom format cannot be applied.");
        }
      if (!J.value) {
        const r = e.value.style.chart.tooltip.showPercentage ? `<div>${j({
          p: e.value.style.chart.tooltip.translations.percentOfTotal,
          v: i.percentOfTotal,
          s: "%",
          r: e.value.style.chart.tooltip.roundingPercentage
        })}</div>` : "";
        f += `<div style="width:100%;text-align:center;border-bottom:1px solid ${e.value.style.chart.tooltip.borderColor};padding-bottom:6px;margin-bottom:3px;"><span style="margin-right:4px; color:${i.color}">⏹</span>${i.name}${r}</div>`, i.from.length && (f += `<div>${e.value.style.chart.tooltip.translations.from}</div>`, i.from.forEach((h) => {
          f += `<div><span style="color:${h.color}">⏹←</span> ${h.source}: ${fe(
            e.value.style.chart.nodes.labels.formatter,
            h.value,
            j({
              p: e.value.style.chart.nodes.labels.prefix,
              v: h.value,
              s: e.value.style.chart.nodes.labels.suffix,
              r: e.value.style.chart.nodes.labels.rounding
            })
          )}</div>`;
        })), i.to.length && (f += `<div style="margin-top:6px;">${e.value.style.chart.tooltip.translations.to}</div>`, i.to.forEach((h) => {
          f += `<div><span style="color:${h.color}">⏹→</span> ${h.target}: ${fe(
            e.value.style.chart.nodes.labels.formatter,
            h.value,
            j({
              p: e.value.style.chart.nodes.labels.prefix,
              v: h.value,
              s: e.value.style.chart.nodes.labels.suffix,
              r: e.value.style.chart.nodes.labels.rounding
            })
          )}</div>`;
        })), ne.value = f;
      }
    }
    function Oe() {
      w.value = null, A.value = null, ae.value = !1;
    }
    const Se = m(() => C.value.links.map(
      ({ source: t, target: l, sourceColor: o, targetColor: a, value: s }) => ({
        source: t,
        target: l,
        sourceColor: o,
        targetColor: a,
        value: s
      })
    ));
    function Fe() {
      st(() => {
        const t = Se.value.map((a, s) => [[a.source], [a.target], [a.value]]), l = [
          [e.value.style.chart.title.text],
          [e.value.style.chart.title.subtitle.text],
          [
            [e.value.table.columnNames.source],
            [e.value.table.columnNames.target],
            [e.value.table.columnNames.value]
          ]
        ].concat(t), o = gt(l);
        mt({
          csvContent: o,
          title: e.value.style.chart.title.text || "vue-ui-flow"
        });
      });
    }
    const Z = m(() => {
      const t = [
        e.value.table.columnNames.source,
        e.value.table.columnNames.target,
        e.value.table.columnNames.value
      ], l = Se.value.map((s, p) => [
        {
          color: s.sourceColor,
          name: s.source
        },
        {
          color: s.targetColor,
          name: s.target
        },
        j({
          p: e.value.style.chart.nodes.labels.prefix,
          v: s.value,
          s: e.value.style.chart.nodes.labels.suffix,
          r: e.value.style.chart.nodes.labels.rounding
        })
      ]), o = {
        th: {
          backgroundColor: e.value.table.th.backgroundColor,
          color: e.value.table.th.color,
          outline: e.value.table.th.outline
        },
        td: {
          backgroundColor: e.value.table.td.backgroundColor,
          color: e.value.table.td.color,
          outline: e.value.table.td.outline
        },
        breakpoint: e.value.table.responsiveBreakpoint
      };
      return {
        colNames: [
          e.value.table.columnNames.source,
          e.value.table.columnNames.target,
          e.value.table.columnNames.value
        ],
        head: t,
        body: l,
        config: o
      };
    });
    function et() {
      return C.value;
    }
    function Le() {
      N.value.showTable = !N.value.showTable;
    }
    const K = b(!1);
    function ue() {
      K.value = !K.value;
    }
    function Pe() {
      N.value.showTooltip = !N.value.showTooltip;
    }
    const Ie = m(() => {
      const t = new Set(
        C.value.nodes.map(
          (l) => e.value.nodeCategories[l.name] || "__uncategorized__"
        )
      );
      return Array.from(t).map((l) => ({
        name: l,
        color: e.value.nodeCategoryColors[l] || L[0],
        shape: "square",
        count: C.value.nodes.filter(
          (o) => (e.value.nodeCategories[o.name] || "__uncategorized__") === l
        ).length
      })).map((l, o) => ({
        ...l,
        segregate: () => ie({ legend: l, i: o }),
        opacity: P.value.length ? P.value.includes(o) ? 1 : 0.5 : 1
      }));
    }), Ee = m(
      () => Ie.value.filter((t) => t.name !== "__uncategorized__")
    ), P = b([]);
    function ie({ legend: t, i: l }) {
      var a;
      const o = t.name;
      if ((a = w.value) != null && a.every(
        (s) => e.value.nodeCategories[s] === o
      )) {
        w.value = null, A.value = null, P.value = [];
        return;
      }
      P.value = [l], w.value = C.value.nodes.filter((s) => e.value.nodeCategories[s.name] === o).map((s) => s.name), A.value = null;
    }
    const tt = m(() => ({
      cy: "flow-legend",
      backgroundColor: e.value.style.chart.legend.backgroundColor,
      color: e.value.style.chart.legend.color,
      fontSize: e.value.style.chart.legend.fontSize,
      paddingBottom: e.value.style.chart.legend.paddingBottom,
      fontWeight: e.value.style.chart.legend.bold ? "bold" : "normal"
    }));
    return Ge({
      getData: et,
      generateCsv: Fe,
      generateImage: _e,
      generatePdf: $e,
      toggleTable: Le,
      toggleAnnotator: ue,
      toggleTooltip: Pe,
      drillCategory: ie,
      unselectNode: Oe
    }), (t, l) => (c(), y("div", {
      ref_key: "flowChart",
      ref: le,
      class: He(`vue-ui-flow ${E.value ? "vue-data-ui-wrapper-fullscreen" : ""}`),
      style: F(`font-family:${e.value.style.fontFamily};width:100%; text-align:center;background:${e.value.style.chart.backgroundColor}`),
      id: `flow_${oe.value}`,
      onMouseenter: l[3] || (l[3] = () => v(me)(!0)),
      onMouseleave: l[4] || (l[4] = () => v(me)(!1))
    }, [
      e.value.userOptions.buttons.annotator ? (c(), H(xt, {
        key: 0,
        svgRef: v(be),
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        active: K.value,
        onClose: ue
      }, null, 8, ["svgRef", "backgroundColor", "color", "active"])) : x("", !0),
      We.value ? (c(), y("div", It, null, 512)) : x("", !0),
      e.value.style.chart.title.text ? (c(), y("div", Et, [
        (c(), H(bt, {
          key: `title_${ge.value}`,
          config: {
            title: {
              cy: "flow-title",
              ...e.value.style.chart.title
            },
            subtitle: {
              cy: "flow-subtitle",
              ...e.value.style.chart.title.subtitle
            }
          }
        }, null, 8, ["config"]))
      ])) : x("", !0),
      e.value.userOptions.show && te.value && (v(ye) || v(se)) ? (c(), H(Ct, {
        ref: "details",
        key: `user_option_${pe.value}`,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        isPrinting: v(Ce),
        isImaging: v(we),
        uid: oe.value,
        hasPdf: e.value.userOptions.buttons.pdf,
        hasXls: e.value.userOptions.buttons.csv,
        hasImg: e.value.userOptions.buttons.img,
        hasTable: e.value.userOptions.buttons.table,
        hasFullscreen: e.value.userOptions.buttons.fullscreen,
        isFullscreen: E.value,
        titles: { ...e.value.userOptions.buttonTitles },
        chartElement: le.value,
        position: e.value.userOptions.position,
        hasAnnotator: e.value.userOptions.buttons.annotator,
        isAnnotation: K.value,
        hasTooltip: e.value.style.chart.tooltip.show && e.value.userOptions.buttons.tooltip,
        isTooltip: N.value.showTooltip,
        onToggleTooltip: Pe,
        onToggleFullscreen: Ve,
        onGeneratePdf: v($e),
        onGenerateCsv: Fe,
        onGenerateImage: v(_e),
        onToggleTable: Le,
        onToggleAnnotator: ue,
        style: F({
          visibility: v(ye) ? v(se) ? "visible" : "hidden" : "visible"
        })
      }, at({ _: 2 }, [
        t.$slots.menuIcon ? {
          name: "menuIcon",
          fn: $(({ isOpen: o, color: a }) => [
            k(t.$slots, "menuIcon", D(B({ isOpen: o, color: a })), void 0, !0)
          ]),
          key: "0"
        } : void 0,
        t.$slots.optionTooltip ? {
          name: "optionTooltip",
          fn: $(() => [
            k(t.$slots, "optionTooltip", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        t.$slots.optionPdf ? {
          name: "optionPdf",
          fn: $(() => [
            k(t.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "2"
        } : void 0,
        t.$slots.optionCsv ? {
          name: "optionCsv",
          fn: $(() => [
            k(t.$slots, "optionCsv", {}, void 0, !0)
          ]),
          key: "3"
        } : void 0,
        t.$slots.optionImg ? {
          name: "optionImg",
          fn: $(() => [
            k(t.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "4"
        } : void 0,
        t.$slots.optionTable ? {
          name: "optionTable",
          fn: $(() => [
            k(t.$slots, "optionTable", {}, void 0, !0)
          ]),
          key: "5"
        } : void 0,
        t.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: $(({ toggleFullscreen: o, isFullscreen: a }) => [
            k(t.$slots, "optionFullscreen", D(B({ toggleFullscreen: o, isFullscreen: a })), void 0, !0)
          ]),
          key: "6"
        } : void 0,
        t.$slots.optionAnnotator ? {
          name: "optionAnnotator",
          fn: $(({ toggleAnnotator: o, isAnnotator: a }) => [
            k(t.$slots, "optionAnnotator", D(B({ toggleAnnotator: o, isAnnotator: a })), void 0, !0)
          ]),
          key: "7"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isPrinting", "isImaging", "uid", "hasPdf", "hasXls", "hasImg", "hasTable", "hasFullscreen", "isFullscreen", "titles", "chartElement", "position", "hasAnnotator", "isAnnotation", "hasTooltip", "isTooltip", "onGeneratePdf", "onGenerateImage", "style"])) : x("", !0),
      (c(), y("svg", {
        ref_key: "svgRef",
        ref: be,
        xmlns: v(ht),
        viewBox: `0 0 ${G.value.width} ${G.value.height}`,
        class: He({
          "vue-data-ui-fullscreen--on": E.value,
          "vue-data-ui-fulscreen--off": !E.value
        }),
        style: F(`max-width:100%; overflow: visible; background:transparent;color:${e.value.style.chart.color}`)
      }, [
        de(Tt),
        t.$slots["chart-background"] ? (c(), y("foreignObject", {
          key: 0,
          x: 0,
          y: 0,
          width: G.value.width,
          height: G.value.height,
          style: {
            pointerEvents: "none"
          }
        }, [
          k(t.$slots, "chart-background", {}, void 0, !0)
        ], 8, At)) : x("", !0),
        Y("defs", null, [
          (c(!0), y(U, null, V(C.value.links, (o, a) => (c(), y("linearGradient", {
            id: o.id,
            x1: "0%",
            y1: "0%",
            x2: "100%",
            y2: "0%"
          }, [
            Y("stop", {
              offset: "0%",
              "stop-color": o.sourceColor
            }, null, 8, Ht),
            Y("stop", {
              offset: "100%",
              "stop-color": o.targetColor
            }, null, 8, Yt)
          ], 8, Mt))), 256))
        ]),
        (c(!0), y(U, null, V(C.value.links, (o) => (c(), y("path", {
          class: "vue-ui-flow-link",
          d: o.path,
          fill: `url(#${o.id})`,
          stroke: e.value.style.chart.links.stroke,
          "stroke-width": e.value.style.chart.links.strokeWidth,
          style: F(`
                    opacity:${w.value ? w.value.includes(o.source) && w.value.includes(o.target) ? 1 : 0.3 : A.value ? [o.target, o.source].includes(A.value) ? 1 : 0.3 : e.value.style.chart.links.opacity}
                `)
        }, null, 12, Dt))), 256)),
        (c(!0), y(U, null, V(C.value.nodes, (o, a) => (c(), y("rect", {
          class: "vue-ui-flow-node",
          x: o.x,
          y: v(_)(o.absoluteY) + e.value.style.chart.padding.top,
          height: v(_)(o.height),
          width: z.value,
          fill: o.color,
          stroke: e.value.style.chart.nodes.stroke,
          "stroke-width": e.value.style.chart.nodes.strokeWidth,
          onMouseenter: (s) => Qe(o),
          onMouseleave: l[0] || (l[0] = (s) => Oe()),
          style: F(`opacity:${w.value ? w.value.includes(o.name) ? 1 : 0.3 : 1}`)
        }, null, 44, Bt))), 256)),
        (c(!0), y(U, null, V(C.value.nodes, (o, a) => (c(), y("text", {
          x: o.x + z.value / 2,
          y: v(_)(
            o.absoluteY + o.height / 2 - e.value.style.chart.nodes.labels.fontSize / 4
          ) + e.value.style.chart.padding.top,
          "font-size": e.value.style.chart.nodes.labels.fontSize,
          fill: v(Ye)(o.color),
          "text-anchor": "middle",
          style: F(`pointer-events: none; opacity:${w.value ? w.value.includes(o.name) ? 1 : 0 : 1}`)
        }, W(e.value.style.chart.nodes.labels.abbreviation.use ? v(pt)({
          source: o.name,
          length: e.value.style.chart.nodes.labels.abbreviation.length
        }) : o.name), 13, Gt))), 256)),
        (c(!0), y(U, null, V(C.value.nodes, (o, a) => (c(), y("text", {
          x: o.x + z.value / 2,
          y: v(_)(
            o.absoluteY + o.height / 2 + e.value.style.chart.nodes.labels.fontSize
          ) + e.value.style.chart.padding.top,
          "font-size": e.value.style.chart.nodes.labels.fontSize,
          fill: v(Ye)(o.color),
          "text-anchor": "middle",
          style: F(`pointer-events: none; opacity:${w.value ? w.value.includes(o.name) ? 1 : 0 : 1}`)
        }, W(v(fe)(
          e.value.style.chart.nodes.labels.formatter,
          o.value,
          v(j)({
            p: e.value.style.chart.nodes.labels.prefix,
            v: o.value,
            s: e.value.style.chart.nodes.labels.suffix,
            r: e.value.style.chart.nodes.labels.rounding
          }),
          { datapoint: o, seriesIndex: a }
        )), 13, Rt))), 256)),
        k(t.$slots, "svg", { svg: G.value }, void 0, !0)
      ], 14, zt)),
      t.$slots.watermark ? (c(), y("div", Ut, [
        k(t.$slots, "watermark", D(B({ isPrinting: v(Ce) || v(we) })), void 0, !0)
      ])) : x("", !0),
      te.value ? x("", !0) : (c(), H(_t, {
        key: 5,
        config: {
          type: "flow",
          style: {
            backgroundColor: e.value.style.chart.backgroundColor
          }
        }
      }, null, 8, ["config"])),
      Y("div", {
        ref_key: "chartLegend",
        ref: Ue
      }, [
        e.value.style.chart.legend.show && Ee.value.length ? (c(), H(Ft, {
          key: 0,
          legendSet: Ee.value,
          config: tt.value,
          onClickMarker: l[1] || (l[1] = (o) => ie(o))
        }, {
          item: $(({ legend: o, index: a }) => [
            Y("div", {
              onClick: (s) => o.segregate(),
              style: F(`opacity:${P.value.length ? P.value.includes(a) ? 1 : 0.5 : 1}`)
            }, W(o.name) + " (" + W(o.count) + ") ", 13, Vt)
          ]),
          _: 1
        }, 8, ["legendSet", "config"])) : x("", !0),
        k(t.$slots, "legend", { legend: Ie.value }, void 0, !0)
      ], 512),
      t.$slots.source ? (c(), y("div", Wt, [
        k(t.$slots, "source", {}, void 0, !0)
      ], 512)) : x("", !0),
      de(St, {
        show: N.value.showTooltip && ae.value,
        backgroundColor: e.value.style.chart.tooltip.backgroundColor,
        color: e.value.style.chart.tooltip.color,
        fontSize: e.value.style.chart.tooltip.fontSize,
        borderRadius: e.value.style.chart.tooltip.borderRadius,
        borderColor: e.value.style.chart.tooltip.borderColor,
        borderWidth: e.value.style.chart.tooltip.borderWidth,
        backgroundOpacity: e.value.style.chart.tooltip.backgroundOpacity,
        position: e.value.style.chart.tooltip.position,
        offsetY: e.value.style.chart.tooltip.offsetY,
        parent: le.value,
        content: ne.value,
        isCustom: J.value,
        isFullscreen: E.value
      }, {
        "tooltip-before": $(() => [
          k(t.$slots, "tooltip-before", D(B({ ...re.value })), void 0, !0)
        ]),
        "tooltip-after": $(() => [
          k(t.$slots, "tooltip-after", D(B({ ...re.value })), void 0, !0)
        ]),
        _: 3
      }, 8, ["show", "backgroundColor", "color", "fontSize", "borderRadius", "borderColor", "borderWidth", "backgroundOpacity", "position", "offsetY", "parent", "content", "isCustom", "isFullscreen"]),
      te.value ? (c(), H($t, {
        key: 7,
        hideDetails: "",
        config: {
          open: N.value.showTable,
          maxHeight: 1e4,
          body: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          },
          head: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          }
        }
      }, {
        content: $(() => [
          de(wt, {
            colNames: Z.value.colNames,
            head: Z.value.head,
            body: Z.value.body,
            config: Z.value.config,
            title: `${e.value.style.chart.title.text}${e.value.style.chart.title.subtitle.text ? ` : ${e.value.style.chart.title.subtitle.text}` : ""}`,
            onClose: l[2] || (l[2] = (o) => N.value.showTable = !1)
          }, {
            th: $(({ th: o }) => [
              Y("div", {
                innerHTML: o,
                style: { display: "flex", "align-items": "center" }
              }, null, 8, jt)
            ]),
            td: $(({ td: o }) => [
              nt(W(o.name || o), 1)
            ]),
            _: 1
          }, 8, ["colNames", "head", "body", "config", "title"])
        ]),
        _: 1
      }, 8, ["config"])) : x("", !0)
    ], 46, Pt));
  }
}, co = /* @__PURE__ */ Lt(Xt, [["__scopeId", "data-v-e6473b78"]]);
export {
  co as default
};
